{# _datamax/api/templates/files/add_config.html_ #}
{% extends "validation_layout.html" %}

{% block body %}
<div class="row">
    <div class="col-md-8">
        <h5 class="card-title">Add validation configuration - {{ request.args.get('name') }} [{{
            request.args.get('source_type') }}]</h5>
    </div>
    <div class="col-md-4 text-right">

    </div>
</div>
<br/>
<form method="post" action="{{ url_for('config.add') }}" id="addConfigForm">
    <div class="row">
        <div class="col-md-7">
            <div class="form-group">
                <label for="name">Configuration name</label>
                <input type="text" class="form-control" id="name" placeholder="" name="name" required>
                <small id="nameHelp" class="form-text text-muted">
                    Configuration name used as key for reference.
                </small>
            </div><!-- .name -->
            <div class="form-group">
                <label for="projectName">Project</label>
                <input type="text" class="form-control" id="projectName" name="project_name" readonly value="">
                <small id="projectHelp" class="form-text text-muted">

                </small>
            </div><!-- .project name -->
            <div class="form-group">
                <label for="connectionName">Connection</label>
                <input type="text" class="form-control" id="connectionName" name="connection_name" readonly value="">
                <small id="connectionHelp" class="form-text text-muted">

                </small>
            </div><!-- .project name -->
            <br>
            <input type="submit" class="btn btn-primary float-right" name="submit" value="Save">
        </div>
        <br><br>
        <div class="col-md-5">
            <div id="inputFileDetails">
                <h6>
                    <i class="fas fa-pen-square"></i> Input file details
                </h6>
                <div class="form-group row">
                    <label class="col-sm-5 col-form-label" for="description">Description</label>
                    <input type="text" readonly class="form-control-plaintext col-sm-7" id="description"
                           placeholder="" value="">
                </div>

                <input type="hidden" name="project_id" id="projectId" value="" />
                <input type="hidden" name="file_id" value="{{ request.args.get('file_id') }}" />
                <input type="hidden" name="system_defined" value="[]">
                <input type="hidden" name="user_defined" value="[]">
            </div>
            <br><br>
        </div>
    </div><!-- class row -->
</form>
<div class="row">
    <div class="col-md-7">
        <h6><i class="fas fa-clipboard-check"></i>&ensp;&ensp;Validation Rules</h6>
        <div id="accordion">
            <div class="card">
                <div class="card-header" id="headingOne">
                    <h5 class="mb-0">
                        <span class="btn" data-toggle="collapse" data-target="#collapseOne"
                              aria-expanded="true" aria-controls="collapseOne">
                            <i class="fas fa-caret-right"></i>&ensp;&ensp;<i
                                class="fas fa-user-cog"></i> user
                            defined
                        </span>
                    </h5>
                </div>

                <div id="collapseOne" class="collapse show" aria-labelledby="headingOne"
                     data-parent="#accordion">
                    <div class="card-body">
                    </div>
                    <ul class="list-group list-group-flush" id="list-group-user-defined">
                    </ul>
                </div>
            </div><!-- .card -->
            <div class="card">
                <div class="card-header" id="headingTwo">
                    <h5 class="mb-0">
                        <span class="btn collapsed" data-toggle="collapse"
                              data-target="#collapseTwo"
                              aria-expanded="false" aria-controls="collapseTwo">
                            <i class="fas fa-caret-right"></i>&ensp;&ensp;<i
                                class="fas fa-cogs"></i> system defined
                        </span>
                    </h5>
                </div>
                <div id="collapseTwo" class="collapse" aria-labelledby="headingTwo"
                     data-parent="#accordion">
                    <div class="card-body">
                        These rules are applied by the system based on their given data type.
                    </div>
                    <ul class="list-group list-group-flush" id="list-group-system-defined">
                    </ul>
                </div>
            </div>
        </div><!-- .accordion -->
    </div>
    <div class="col-md-5">
        <h6>
            <i class="fas fa-university"></i> Rule Library
        </h6>
        <br>
        <input type="text" class="form-control form-control-sm" placeholder="Search"
               id="searchRuleLibrary">
        <br>
        <div>
            <ul class="list-group list-group-flush" id="rule-library">
            </ul>
        </div>
    </div>
</div> <!-- second row ends  -->
<script>
    $(document).ready(function(){
        var fileId = {{ request.args.get('file_id') }};

        // Add caret-down icon for collapse element which is open by default
        $(".collapse.show").each(function(){
        	$(this).prev(".card-header").find(".fa-caret-right").addClass("fa-caret-down").removeClass("fa-caret-right");
        });

        // Toggle plus caret-right icon on show hide of collapse element
        $(".collapse").on('show.bs.collapse', function(){
        	$(this).prev(".card-header").find(".fa-caret-right").removeClass("fa-caret-right").addClass("fa-caret-down");
        }).on('hide.bs.collapse', function(){
        	$(this).prev(".card-header").find(".fa-caret-down").removeClass("fa-caret-down").addClass("fa-caret-right");
        });

        //system defined rules - initial load
        //$("input[name='system_defined']").attr('value', $("input[name='system_defined']").val().replace(/'/g, '"'));
        //var systemDefinedRules = JSON.parse($("input[name='system_defined']").val());
        var systemDefinedRules = {};

        //user defined rules - initial load
        //$("input[name='user_defined']").attr('value', $("input[name='user_defined']").val().replace(/'/g, '"'));
        //var userDefinedRules = JSON.parse($("input[name='user_defined']").val());

        //all rules
        var allRules = {};
        $.get("{{ url_for('api_exchange.index') }}?name=all_rules", function (data) {
            $.each(data.Contents, function(index, val) {
                allRules[val.id] = {"name": val.name, "description": val.ui_description, "params": val.parameters};
                $("#rule-library").append('\
                    <li class="list-group-item">\
                        <div class="row">\
                            <div class="col-md-10">\
                                <div class="h7 text-muted">\
                                    ' + val.name + '&ensp; ' + val.datatype + '\
                                </div>\
                                <div class="h6">' + val.description + '</div>\
                            </div>\
                            <div class="col-md-2">\
                                <div class="float-right btn btn-link addRule"\
                                     ruleId="' +val.id + '">\
                                    <i class="fas fa-plus-square">\
                                    </i>\
                                </div>\
                            </div>\
                        </div>\
                    </li>\
                ');
            });
            console.log(allRules);
        });

        // -------------------------------------------------------------------------------------------------------------
        // file load
        // -------------------------------------------------------------------------------------------------------------
        var shape;
        console.log("Requesting for file details...");
        $.get("{{ url_for('api_exchange.index') }}?name=get_file&id=" + fileId, function (data) {
            console.log(data);
            shape = data.Contents[0].shape;
            $("#projectName").val(data.Contents[0].project_name);
            $("#connectionName").val(data.Contents[0].connector_name);
            $("#description").val(data.Contents[0].description);
            $("#projectId").val(data.Contents[0].project_id);
            $.each(data.Contents[0].properties, function(key, val){
                $("#inputFileDetails").append('\
                    <div class="form-group row">\
                        <label class="col-sm-5 col-form-label">' + key + '</label>\
                        <input type="text" readonly class="form-control-plaintext col-sm-7"\
                               placeholder=""\
                               value="' + val +'">\
                    </div>\
                ');
            });

        });
        // -------------------------------------------------------------------------------------------------------------

        // -------------------------------------------------------------------------------------------------------------
        //system rule load
        // -------------------------------------------------------------------------------------------------------------
        $.each(systemDefinedRules, function(index, systemDefinedRule){
            rule = jQuery.extend({}, allRules.filter(({id}) => id == systemDefinedRule.id)[0]);
            $.each(systemDefinedRule.parameters, function(paramIndex, parameter) {
                rule.ui_description = rule.ui_description.replace("{" + parameter.param + "}", parameter.value);
                });
            $("#list-group-system-defined").append('\
                <li class="list-group-item">\
                <div class="row">\
                    <div class="col-md-10">\
                        <div class="h7 text-muted">' + rule.name + '</div>\
                        <div class="h6">' + rule.ui_description +'</div>\
                    </div>\
                    <div class="col-md-2">\
                        <div class="float-right"><i class="far fa-copy"></i> <i class="far fa-trash-alt"></i></div>\
                    </div>\
                </div>\
                </li>\
            ');
        });
        // system rule ends
        // -------------------------------------------------------------------------------------------------------------


        // -------------------------------------------------------------------------------------------------------------
        // user defined load
        // -------------------------------------------------------------------------------------------------------------
        $("#rule-library").on('click', '.addRule', function(){
            var ruleId = $(this).attr("ruleId");
            loadRuleHTML(ruleId);
        });
        // -------------------------------------------------------------------------------------------------------------

        //search rule library
        $("#searchRuleLibrary").on("keyup", function() {
            var value = $(this).val().toLowerCase();
            $("#rule-library li").filter(function() {
                $(this).toggle($(this).text().toLowerCase().indexOf(value) > -1)
            });
        });

        // delete the rule
        $("#list-group-user-defined").on("click", ".fa-trash-alt.enabled", function(){
            $(this).parents('.list-group-item').remove();
        });

        // copy the rule
        $("#list-group-user-defined").on("click", ".fa-copy.enabled", function(){
            $('#list-group-user-defined').append($(this).parents('.list-group-item').clone());
        });

        // form submit
        $("#addConfigForm").submit(function(){
            var userDefinedRules = [];
            $(".rule-description").each(function(index) {
                var params = [];
                $(this).children("input, select").each(function(index){
                    params.push({"param": $(this).attr("name"), "value": $(this).val()});
                });
                 userDefinedRules.push({"id": $(this).attr("rule-id"), "parameters": params});
            });
            $("input[name='user_defined']").attr('value', JSON.stringify(userDefinedRules));
            $.ajax({
                 type: "GET",
                 url: $("#addConfigForm").attr('action'),
                 data: $("#addConfigForm").serialize(),
                 success: function(data) {
                    console.log(data);
                    window.location.href = "{{ url_for('views_validation.list_config') }}?file_id={{ request.args.get('file_id') }}&source_type={{ request.args.get('source_type') }}&name={{ request.args.get('name') }}";
                 }
               }); // .second request ends
            return false;
        });

    function loadRuleHTML(ruleId){
        var currentRule = allRules[ruleId];
            var ruleDescription = currentRule.description;
            var ruleParams = currentRule.params;
            var ruleName = currentRule.name;


            $.each(ruleParams, function(index, parameter) {
                if(ruleDescription.includes('{' + parameter.param + '}')){
                    // -- custom params --
                    if(parameter.type == 'param'){
                        if (parameter.datatype == 'numeric'){
                            ruleDescription = ruleDescription.replace(
                                            '{' + parameter.param + '}',
                                            '&ensp;<input type="number" step="any" name="' + parameter.param + '" '
                                            + ' class="form-control form-control-sm col-md-2"/>&ensp;&ensp;');
                            console.log(parameter.param + " ---> " + ruleDescription);
                            console.log("-------------------------------------------");
                        }
                        if (parameter.datatype == 'varchar'){
                            ruleDescription = ruleDescription.replace(
                                            '{' + parameter.param + '}',
                                            '&ensp;<input type="text" name="' + parameter.param + '" '
                                            + ' class="form-control form-control-sm col-md-2"/>&ensp;&ensp;');
                            console.log(parameter.param + " ---> " + ruleDescription);
                            console.log("-------------------------------------------");
                        }
                        if (parameter.datatype == 'date'){
                            ruleDescription = ruleDescription.replace(
                                            '{' + parameter.param + '}',
                                            '&ensp;<input type="date" name="' + parameter.param + '" '
                                            + ' class="form-control form-control-sm col-md-2"/>&ensp;&ensp;');
                            console.log(parameter.param + " ---> " + ruleDescription);
                            console.log("-------------------------------------------");
                        }
                        if (parameter.datatype == 'picklist'){
                            var columnOptions = '&ensp;<select name="' + parameter.param + '" class="form-control form-control-sm">';
                            $.each(parameter.value.split("|"), function(index, value){
                                columnOptions += '<option value="' + value +'">' + value +'</option>';
                            });
                            columnOptions += '</select>&ensp;&ensp;';
                            ruleDescription = ruleDescription.replace('{' + parameter.param + '}', columnOptions);
                            console.log(parameter.param + " ---> " + ruleDescription);
                            console.log("-------------------------------------------");
                        }
                    } // -- param if ends --

                    // -- predefined params -- like column name
                    else if(parameter.type == 'column'){
                        if (parameter.datatype != 'any'){
                            var columns = shape.filter(({dtype}) => dtype == parameter.datatype);
                        }
                        else {
                            var columns = shape;
                        }
                        var columnOptions = '&ensp;<select name="' + parameter.param +'" class="form-control form-control-sm">';
                        $.each(columns, function(index, column){
                            columnOptions += '<option value="' + column.name +'">' + column.name +'</option>';
                        });
                        columnOptions += '</select>&ensp;&ensp;';
                        ruleDescription = ruleDescription.replace('{' + parameter.param + '}', columnOptions);
                        console.log(ruleDescription);
                        console.log("-------------------------------------------");
                    } // -- column if ends --
                }
            });

            $("#list-group-user-defined").append('\
                <li class="list-group-item">\
                <div class="row">\
                    <div class="col-md-10">\
                        <div class="h7 text-muted">' + ruleName + '</div>\
                        <div class="h6 form-inline rule-description" rule-id="' + ruleId + '">' + ruleDescription +'</div>\
                    </div>\
                    <div class="col-md-2">\
                        <div class="float-right"><i class="far fa-copy enabled"></i> <i class="far fa-trash-alt enabled"></i></div>\
                    </div>\
                </div>\
                </li>\
                ');

    } // .function loadRuleHTML ends --

    });



</script>
{% endblock %}